// Generated by CoffeeScript 1.12.7
(function() {
  var blue, color, console_error, console_info, console_log, console_noop, console_warn, defaultConfig, gray, green, initialize, moment, now, orange, purple, red, validateLevel, yellow,
    slice = [].slice;

  moment = require('moment');

  color = require('@buzuli/color');

  red = color.red, orange = color.orange, yellow = color.yellow, green = color.green, blue = color.blue, purple = color.purple, gray = color.gray;

  console_error = console.error;

  console_warn = console.warn;

  console_log = console.log;

  console_info = console.info;

  console_noop = (function(_this) {
    return function() {
      return {};
    };
  })(this);

  now = function(mode) {
    var D, H, M, S, T, Y, Z, c, d, m, p, s, ts;
    if (mode === 'local') {
      return blue(moment().format("YYYY-MM-DDTHH:mm:ss.SSSZ"));
    } else if (mode === 'unix') {
      return blue("" + (Date.now()));
    } else if (mode === 'pony') {
      ts = moment.utc();
      d = gray('-');
      T = gray('T');
      c = gray(':');
      p = gray('.');
      Y = purple(ts.format('YYYY'));
      M = blue(ts.format('MM'));
      D = green(ts.format('DD'));
      H = yellow(ts.format('HH'));
      m = orange(ts.format('mm'));
      s = red(ts.format('ss'));
      S = purple(ts.format('SSS'));
      Z = blue('Z');
      return "" + Y + d + M + d + D + T + H + c + m + c + s + p + S + Z;
    } else if (mode === 'coded') {
      ts = moment.utc();
      d = gray('-');
      T = gray('T');
      c = gray(':');
      p = gray('.');
      Y = blue(ts.format('YYYY'));
      M = blue(ts.format('MM'));
      D = blue(ts.format('DD'));
      H = yellow(ts.format('HH'));
      m = yellow(ts.format('mm'));
      s = yellow(ts.format('ss'));
      S = yellow(ts.format('SSS'));
      Z = gray('Z');
      return "" + Y + d + M + d + D + T + H + c + m + c + s + p + S + Z;
    } else {
      return blue(moment.utc().toISOString());
    }
  };

  defaultConfig = {
    mode: 'utc',
    console: true,
    alias: void 0
  };

  validateLevel = function(defaultLabel, defaultEnabled) {
    if (defaultEnabled == null) {
      defaultEnabled = true;
    }
    return function(cfgValue) {
      if (cfgValue != null) {
        if (cfgValue === true) {
          return defaultLabel;
        } else {
          return cfgValue;
        }
      } else {
        if (defaultEnabled) {
          return defaultLabel;
        } else {
          return false;
        }
      }
    };
  };

  initialize = function(config) {
    var alias, cfg, error, info, logger, ref, ref1, ref2, sub, verbose, warn;
    if (config == null) {
      config = {};
    }
    cfg = {
      mode: (ref = config.mode) != null ? ref : defaultConfig.mode,
      console: (ref1 = config.console) != null ? ref1 : defaultConfig.console,
      alias: (ref2 = config.alias) != null ? ref2 : defaultConfig.alias,
      error: validateLevel('ERROR')(config.error),
      warn: validateLevel('WARN')(config.warn),
      info: validateLevel('INFO')(config.info),
      verbose: validateLevel('VERBOSE', false)(config.verbose)
    };
    alias = cfg.alias != null ? (orange(cfg.alias)) + "|" : "";
    error = cfg.error ? (red(cfg.error)) + ">" : false;
    warn = cfg.warn ? (yellow(cfg.warn)) + ">" : false;
    info = cfg.info ? (green(cfg.info)) + ">" : false;
    verbose = cfg.verbose ? (purple(cfg.verbose)) + ">" : false;
    sub = function(logger, categoryLabel) {
      if (categoryLabel) {
        return function() {
          var args, first, message, rest;
          args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
          first = args[0], rest = 2 <= args.length ? slice.call(args, 1) : [];
          message = "[" + (now(cfg.mode)) + "]" + alias + categoryLabel + " " + (first != null ? first : '');
          return logger.apply(null, [message].concat(slice.call(rest)));
        };
      } else {
        return function() {};
      }
    };
    logger = {
      error: sub(console_error, error),
      warn: sub(console_warn, warn),
      info: sub(console_info, info),
      verbose: sub(console_info, verbose),
      color: color
    };
    console.error = cfg.console ? logger.error : console_error;
    console.warn = cfg.console ? logger.warn : console_warn;
    console.log = cfg.console ? logger.info : console_log;
    console.info = cfg.console ? logger.info : console_info;
    console.verbose = cfg.console ? logger.verbose : console_noop;
    return logger;
  };

  module.exports = initialize;

}).call(this);
